/*

    Magic MS Creator est un programme pour PC permettant de crer une Memory Stick "Pandora" directement depuis le PC avec la connexion USB.

    Copyright (C) 2008  Roomain

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>

int formatterMS(char *lettre)
{
	char * cheminFormat = "";
	sprintf(cheminFormat, "@format %s: /autotest", lettre);
	system(cheminFormat);      
	return 0;
}

int formatLogically(char *lettre)
{
	char * cheminFormat = "";
	sprintf(cheminFormat, "@mspformat.exe %s /y", lettre);
	system(cheminFormat);
	return 0;
}

int createDirectories(char *lettre)
{
	char * repertoire ="";
	sprintf(repertoire, "%s:/TM", lettre);
	mkdir(repertoire);
	repertoire ="";
	sprintf(repertoire, "%s:/TM/DC5", lettre);
	mkdir(repertoire);
	repertoire ="";
	sprintf(repertoire, "%s:/TM/DC5/kd", lettre);
	mkdir(repertoire);
	repertoire ="";
	sprintf(repertoire, "%s:/TM/registry", lettre);
	mkdir(repertoire);
}

int copy(char *origin, char *dest)
{

	char chaineLue[10000] = "";
	FILE* origine = NULL;
	FILE* destination = NULL;
	origine = fopen(origin, "r");
	destination = fopen(dest, "w+");
	
	while (fgets(chaineLue, 10000, origine) != NULL)
        {
        	fprintf(destination, "%s", chaineLue);
        }
        
        fclose(origine);
        fclose(destination);
        

}

int moveFiles(char *lettre)
{

	struct dirent *lecture;
	DIR *rep;
	char * repertoireToMove = "";
	sprintf(repertoireToMove, "./ms/TM/DC5/kd");
	char * destination = "";
	sprintf(destination, "%s:/TM/DC5/kd", lettre);
	rep = opendir(repertoireToMove);
	while ((lecture = readdir(rep)))
	{
		char * fichierTrouve = "";
		sprintf(fichierTrouve, "%s/%s", repertoireToMove, lecture->d_name);
		char * destinationComplete = "";
		sprintf(destinationComplete, "%s/%s", destination, lecture->d_name);
		copy(fichierTrouve, destinationComplete);
	}
	closedir(rep);
	
	repertoireToMove = "";
	sprintf(repertoireToMove, "./ms/TM/DC5/registry");
	destination = "";
	sprintf(destination, "%s:/TM/DC5/registry", lettre);
	rep = opendir(repertoireToMove);
	while ((lecture = readdir(rep)))
	{
		char * fichierTrouve = "";
		sprintf(fichierTrouve, "%s/%s", repertoireToMove, lecture->d_name);
		char * destinationComplete = "";
		sprintf(destinationComplete, "%s/%s", destination, lecture->d_name);
		copy(fichierTrouve, destinationComplete);
	}
	closedir(rep);
	
	char * MSto = "";
	sprintf(MSto, "%s:/390.PBP", lettre);
	copy("./ms/390.PBP", MSto);
	
	MSto = "";
	sprintf(MSto, "%s:/TM/DC5/ipl.bin", lettre);
	copy("./ms/TM/DC5/ipl.bin", MSto);
	
	

}

int IPLFlashing(char * lettre)
{
    char * commande = "";
    sprintf(commande, "@msinst.exe %s msipl.bin /y", lettre);
    system(commande);
}

int main()
{
	
	printf("Veuillez saisir la lettre de votre PSP : ");
	char * lettrePSP = "";
	scanf("%s", lettrePSP);
	printf("\n\n---------------------------------\n\n");
	printf("Formattage en cours... ");
	formatterMS(lettrePSP);
	printf("Termine !\n");
	printf("Secteur de boot en preparation...");
	formatLogically(lettrePSP);
	printf(" Termine !\n");
	printf("Creation des repertoires... ");
	createDirectories(lettrePSP);
	printf("Termine !\n");
	printf("Copie des fichiers... ");
	moveFiles(lettrePSP);
	printf("Termine !\n");
	printf("Flashage IPL... ");
	IPLFlashing(lettrePSP);
	printf("Termine !\n");
	printf("\n\n---------------------------------\n\n");
	printf("La Memory Stick est prete pour Pandoriser :p");
	system("pause");

}
